            #GIT_CMT=8c5c084a476c4018a514631d140001db503e7736
%global flavor ora

%{!?__python3: %global __python3 /usr/bin/python3}
%global __python %{__python3}
%global python3_sitelib %(%{__python3} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")
%global python_sitelib %{python3_sitelib}

Summary: RDMA userland tools and scripts
Name: oracle-rdma-tools
Version: 0.11.4
Release: 1%{?dist}%{?flavor}
License: GPLv2
Url: https://github.com/aron-silverton/mlnx-tools
Group: Applications/System
Source: oracle-rdma-tools-0.11.4.tar.bz2
BuildRoot: %{?build_root:%{build_root}}%{!?build_root:/var/tmp/%{name}}
Vendor: Oracle
Requires: perl
Requires: python3
Requires: rdma-core >= 5:34.0-1.0.5
BuildRequires: python3

%description
Mellanox userland tools and scripts


%prep
%setup -n %{name}-%{version}

%install

add_env()
{
	efile=$1
	evar=$2
	epath=$3

cat >> $efile << EOF
if ! echo \$${evar} | grep -q $epath ; then
	export $evar=$epath:\$$evar
fi

EOF
}

touch mlnx-tools-files
cd ofed_scripts/utils
mlnx_python_sitelib=%{python_sitelib}
if [ "$(echo %{_prefix} | sed -e 's@/@@g')" != "usr" ]; then
	mlnx_python_sitelib=$(echo %{python_sitelib} | sed -e 's@/usr@%{_prefix}@')
fi
%{__python} setup.py install -O1 --prefix=%{buildroot}%{_prefix} --install-lib=%{buildroot}${mlnx_python_sitelib}
cd -

if [ "$(echo %{_prefix} | sed -e 's@/@@g')" != "usr" ]; then
	conf_env=/etc/profile.d/mlnx-tools.sh
	install -d %{buildroot}/etc/profile.d
	add_env %{buildroot}$conf_env PYTHONPATH $mlnx_python_sitelib
	add_env %{buildroot}$conf_env PATH %{_bindir}
	add_env %{buildroot}$conf_env PATH %{_sbindir}
	echo $conf_env >> mlnx-tools-files
fi
find %{buildroot}${mlnx_python_sitelib} -type f -print | sed -e 's@%{buildroot}@@' >> mlnx-tools-files

install -D -m 0755 ofed_scripts/cma_roce_mode %{buildroot}%{_sbindir}/cma_roce_mode
install -D -m 0755 oracle/roce_config.sh %{buildroot}%{_bindir}/roce_config
install -D -m 0644 oracle/roce.interfaces-conf %{buildroot}%{_sysconfdir}/rdma/roce-interfaces.conf
%if 0%{?rhel} >= 8
install -D -m 0755 oracle/roce-up.sh %{buildroot}%{_sysconfdir}/NetworkManager/dispatcher.d/15-roce-up
%else
install -D -m 0755 oracle/ifup-local %{buildroot}%{_sbindir}/ifup-local
%endif


%clean
rm -rf %{buildroot}

%files -f mlnx-tools-files
%defattr(-,root,root,-)
%dir %{_sysconfdir}/rdma
%config(noreplace) %{_sysconfdir}/rdma/roce-interfaces.conf
%{_sbindir}/*
%{_bindir}/*
%if 0%{?rhel} >= 8
%dir %{_sysconfdir}/NetworkManager/dispatcher.d
%{_sysconfdir}/NetworkManager/dispatcher.d/*
%endif


%changelog
* Tue Nov 29 2022 Mark Haywood <mark.haywood@oracle.com> - 0:0.11.4-1
- roce_config: Fix regression that prevents configuring VFs (Mark Haywood) [Orabug: 34846420]

* Wed Nov 16 2022 Mark Haywood <mark.haywood@oracle.com> - 0:0.11.3-1
- Revert "roce_config: Skip setting buffer sizes for CX7" (Mark Haywood) [Orabug: 34806230]
- roce_config: Only configure CX5 HCAs (Mark Haywood) [Orabug: 34806230]

* Thu Nov 03 2022 Mark Haywood <mark.haywood@oracle.com> - 0:0.11.2-1
- roce_config: Skip setting buffer sizes for CX7 (Mark Haywood) [Orabug: 34458246]

* Wed May 11 2022 Mark Haywood <mark.haywood@oracle.com> - 0:0.11.1-1
- utils: mlnx_qos TCs printed out of order (Mark Haywood) [Orabug: 34161676]

* Tue May 03 2022 Mark Haywood <mark.haywood@oracle.com> - 0:0.11.0-1
- utils: Fix python3 related syntax errors (Mark Haywood) [Orabug: 33846722]
- spec: Use python3 on OL7, OL8 and OL9 (Mark Haywood) [Orabug: 33846722]
- utils: Change all array.fromstring calls to array.frombytes calls (Mark Haywood) [Orabug: 33970224]
- utils: Change all array.tostring calls to array.tobytes calls (Mark Haywood) [Orabug: 33970224]
- spec: Remove roce_config_persistent from the package (Mark Haywood) [Orabug: 33976217]
- roce_config: Update OL version check (Mark Haywood) [Orabug: 33974971]
- utils: Move ibdev2netdev from oracle-rdma-tools to rdma-core (Mark Haywood) [Orabug: 32373791]
- utils: Move show_gids from oracle-rdma-tools to rdma-core (Mark Haywood) [Orabug: 32373797]
- oracle/spec: Update package descriptions and summaries (Mark Haywood) [Orabug: 34110737]
- oracle/spec: Rebuild for OL9 (Mark Haywood) [Orabug: 33836216]

* Mon Mar 07 2022 Mark Haywood <mark.haywood@oracle.com> - 0:0.10.1-1
- ifup-local: Add verbose option for verbose messaging (Mark Haywood) [Orabug: 33441394]

* Thu Feb 20 2020 Aron Silverton <aron.silverton@oracle.com> - 0:0.10.0-1
- {spec,utils}: Use python2 on both OL7 and OL8 (Aron Silverton) [Orabug: 30880962]
- roce_config: Allow the script to run on OL8 (Aron Silverton) [Orabug: 30884858]
- Add NetworkManager dispatcher for RoCE "up" (Aron Silverton) [Orabug: 30931630]
- Add NetworkManager dispatcher for RoCE "up" and "down" (Aron Silverton) [Orabug: 30931630]
- spec: Use Network scripts for OL7 and NetworkManager for OL8 (Aron Silverton) [Orabug: 30931630]

* Mon Aug 12 2019 Mark Haywood <mark.haywood@oracle.com> - 0:0.9.1-1
- roce-config: disable lane 6 on PFC 6 [Orabug: 30155413]

* Fri Aug 02 2019 Aron Silverton <aron.silverton@oracle.com> - 0:0.9.0-1
- ifup-local: Use bash instead of sh (Aron Silverton) [Orabug: 28122139]
- ifup-local: Configure specific interfaces for RoCE (Aron Silverton) [Orabug: 28122139]

* Mon Jun 24 2019 Aron Silverton <aron.silverton@oracle.com> - 0:0.8.2-1
- roce_config: Update the host ToS map again (Santosh Shilimkar) [ Orabug: 29922090]

* Thu Apr 04 2019 Aron Silverton <aron.silverton@oracle.com> - 0:0.8.1-1
- roce_config: Fix setting congestion control parameters (Aron Silverton) [Orabug: 29205754]

* Mon Mar 04 2019 Aron Silverton <aron.silverton@oracle.com> - 0:0.8.0-1
- roce_config: Update MINOR_VERSION (Aron Silverton) [Orabug: 29438055]
- roce_config: Update the host ToS map (Santosh Shilimkar) [Orabug: 29222557]
- roce_config: Set interface Rx buffer size defaults (Aron Silverton) [Orabug: 28716205]

* Tue Jan 08 2019 Aron Silverton <aron.silverton@oracle.com> - 0:0.7.1-1
- roce_config: Do configuration based on PF or VF (Aron Silverton) [Orabug: 27482819]
- roce_config: Fix NETDEV matching and parsing (Aron Silverton) [Orabug: 29030625]

* Fri Nov 09 2018 Aron Silverton <aron.silverton@oracle.com> - 0:0.7.0-2
- spec: Change "vos" to "ora" and update summaries and descriptions [Orabug: 29128747]

* Tue Oct 30 2018 Aron Silverton <aron.silverton@oracle.com> - 0:0.7.0-1
- roce_config: Adjust configuration steps for VFs (Avinash Repaka) [Orabug: 27482819]
- roce_config: Disable CNP configuration for VFs (Aron Silverton) [Orabug: 27482819]
- roce_config: Disable CNP configuration (Aron Silverton) [Orabug: 28600183]
- roce_config: Fix multi-thread race condition (Aron Silverton) [Orabug: 28730043]

* Mon Aug 27 2018 Aron Silverton <aron.silverton@oracle.com> - 0:0.6.0-2
- Add "vos" to RPM release number (Aron Silverton) [Orabug 28550856]

* Mon Jul 09 2018 Aron Silverton <aron.silverton@oracle.com> - 0.6.0-1
- Add COPYING file for OpenIB.org BSD/GPLv2 (Aron Silverton)
- Add UPL copyright notice to Oracle source (Aron Silverton)
- Add COPYING files for individual licenses: UPL, OpenIB/BSD, GPLv2 (Aron Silverton)
- mlnx_qos: Add dcbnl enhancments cleanup code (Parav Pandit) [Orabug: 28314239]
- roce_config: Configure PFC using mlnx_qos (Avinash Repaka) [Orabug: 28194198]

* Tue Jun 12 2018 Aron Silverton <aron.silverton@oracle.com> - 0.5.8-2
- Add Oracle build environment and rename spec file

* Tue May 22 2018 Aron Silverton <aron.silverton@oraclecom> - 0.5.8-1
- Change name to "oracle-rdma-tools" and adjust version

* Thu Apr 05 2018 Aron Silverton <aron.silverton@oracle.com>
- Trigger roce_config on ifup/ifdown (Aron Silverton) [Orabug: 26364780]

* Wed Apr 04 2018 Aron Silverton <aron.silverton@oracle.com>
- Move Oracle files to /oracle (Aron Silverton) [Orabug: 27812014]
- Fix bad email address in changelog

* Tue Dec 19 2017 Aron Silverton <aron.silverton@oracle.com> - 1.5.4-0
- [Orabug: 27284449] Add Oracle copyright and remove Mellanox copyright
- [Orabug: 27284461] Remove obsolete installation script
- [Orabug: 27290597] Add OS distribution to generated package name
- [Orabug: 27290626] Add Python build dependency
- [Orabug: 27290690] Include roce_config_persistent in the RPM

* Wed Nov 1 2017 Vladimir Sokolovsky <vlad@mellanox.com>
- Initial packaging

